Gen-ust-events: use options instead of arguments
[lttng-tools.git] / tests / regression / tools / streaming / test_high_throughput_limits
1 #!/bin/bash
2 #
3 # Copyright (C) - 2012 Christian Babeux <christian.babeux@efficios.com>
4 # David Goulet <dgoulet@efficios.com>
5 #
6 # This library is free software; you can redistribute it and/or modify it under
7 # the terms of the GNU Lesser General Public License as published by the Free
8 # Software Foundation; version 2.1 of the License.
9 #
10 # This library is distributed in the hope that it will be useful, but WITHOUT
11 # ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
12 # FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
13 # details.
14 #
15 # You should have received a copy of the GNU Lesser General Public License
16 # along with this library; if not, write to the Free Software Foundation, Inc.,
17 # 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
18
19 TEST_DESC="Streaming - High throughput with bandwidth limits"
20
21 CURDIR=$(dirname $0)/
22 TESTDIR=$CURDIR/../../..
23 NR_APP_ITER=10
24 NR_ITER=1000000
25 TESTAPP_PATH="$TESTDIR/utils/testapp"
26 TESTAPP_NAME="gen-ust-events"
27 TESTAPP_BIN="$TESTAPP_PATH/$TESTAPP_NAME/$TESTAPP_NAME"
28 SESSION_NAME="high-throughput"
29 EVENT_NAME="tp:tptest"
30 SESSIOND_CTRL_PORT=5342
31 SESSIOND_DATA_PORT=5343
32 DEFAULT_IF="lo"
33
34 TRACE_PATH=$(mktemp -d)
35
36 NUM_TESTS=104
37
38 source $TESTDIR/utils/utils.sh
39
40 if [ ! -x "$TESTAPP_BIN" ]; then
41 BAIL_OUT "No UST events binary detected."
42 fi
43
44 function set_bw_limit
45 {
46 limit=$1
47 ctrlportlimit=$(($limit/10))
48 # failsafe to have at least 1kbit/s for control (in the case where $1 < 10)
49 [ $ctrlportlimit = 0 ] && ctrlportlimit=1
50 # if $1 < 10, we might bust the limit set here, but the
51 # parent qdisc (1:) will always limit us to the right max value
52 dataportlimit=$((9*${ctrlportlimit}))
53
54
55 tc qdisc add dev $DEFAULT_IF root handle 1: htb default 15 >/dev/null 2>&1
56
57 # the total bandwidth is the limit set by the user
58 tc class add dev $DEFAULT_IF parent 1: classid 1:1 htb rate ${limit}kbit ceil ${limit}kbit >/dev/null 2>&1
59 # 1/10 of the bandwidth guaranteed and traffic prioritized for the control port
60 tc class add dev $DEFAULT_IF parent 1:1 classid 1:10 htb rate ${ctrlportlimit}kbit ceil ${limit}kbit prio 1 >/dev/null 2>&1
61 # 9/10 of the bandwidth guaranteed and can borrow up to the total bandwidth (if unused)
62 tc class add dev $DEFAULT_IF parent 1:1 classid 1:11 htb rate ${dataportlimit}kbit ceil ${limit}kbit prio 2 >/dev/null 2>&1
63
64 # filter to assign control traffic to the 1:10 class
65 tc filter add dev $DEFAULT_IF parent 1: protocol ip u32 match ip dport $SESSIOND_CTRL_PORT 0xffff flowid 1:10 >/dev/null 2>&1
66 # filter to assign data traffic to the 1:11 class
67 tc filter add dev $DEFAULT_IF parent 1: protocol ip u32 match ip dport $SESSIOND_DATA_PORT 0xffff flowid 1:11 >/dev/null 2>&1
68
69 ok $? "Set bandwidth limits to ${limit}kbits, ${ctrlportlimit} for control and ${dataportlimit} for data"
70 }
71
72 function reset_bw_limit
73 {
74 tc qdisc del dev $DEFAULT_IF root >/dev/null 2>&1
75 ok $? "Reset bandwith limits"
76 }
77
78 function create_lttng_session_with_uri
79 {
80 sess_name=$1
81 uri=$2
82 # Create session with custom URI
83 $TESTDIR/../src/bin/lttng/$LTTNG_BIN create -U $uri $sess_name >/dev/null 2>&1
84 ok $? "Create session with uri $uri"
85 }
86
87 function run_apps
88 {
89 for i in `seq 1 $NR_APP_ITER`; do
90 # With bandwidth limitation, unfortunately, application easily timeout
91 # due to very slow communication between the consumer and relayd making
92 # the status reply from the consumer quite slow thus delaying the
93 # registration done message.
94 LTTNG_UST_REGISTER_TIMEOUT=-1 $TESTAPP_BIN -i $NR_ITER & >/dev/null 2>&1
95 done
96 }
97
98 function test_high_throughput
99 {
100 NETWORK_URI="net://localhost"
101 create_lttng_session_with_uri $SESSION_NAME $NETWORK_URI
102 enable_ust_lttng_event_ok $SESSION_NAME $EVENT_NAME
103 start_lttng_tracing_ok $SESSION_NAME
104 run_apps
105 diag "Waiting for applications to end"
106 wait
107 pass "waiting done"
108 stop_lttng_tracing_ok $SESSION_NAME
109 destroy_lttng_session_ok $SESSION_NAME
110 validate_event_count
111 }
112
113 function validate_event_count
114 {
115
116 TEMP_FILE=$(mktemp)
117 TEMP_FILE_2=$(mktemp)
118
119 traced=$(babeltrace $TRACE_PATH 2>/dev/null | wc -l)
120 babeltrace $TRACE_PATH >/dev/null 2>$TEMP_FILE_2
121
122 cat $TEMP_FILE_2 | cut -f4 -d " " >$TEMP_FILE
123
124 dropped=0
125 while read line;
126 do
127 let dropped=$dropped+$line
128 done < $TEMP_FILE
129
130 let total=$dropped+$traced
131 let wanted=$NR_APP_ITER*$NR_ITER
132
133 if [ $wanted -ne $total ]; then
134 fail "Validate trace event count"
135 diag "Expected $wanted. Dropped $dropped. Recorded $traced. Total $total... "
136 return 1
137 else
138 pass "Validate trace event count"
139 diag "Expected $wanted. Dropped $dropped. Recorded $traced. Total $total... "
140
141 rm -rf $TRACE_PATH
142 rm $TEMP_FILE $TEMP_FILE_2
143
144 return 0
145 fi
146 }
147
148 function interrupt_cleanup()
149 {
150 diag "*** Exiting ***"
151 stop_lttng_relayd
152 stop_lttng_sessiond
153 reset_bw_limit
154 exit 1
155 }
156
157 plan_tests $NUM_TESTS
158
159 print_test_banner "$TEST_DESC"
160
161 if [ "$(id -u)" == "0" ]; then
162 isroot=1
163 else
164 isroot=0
165 fi
166
167 skip $isroot "Root access is needed to set bandwith limits. Skipping all tests." $NUM_TESTS ||
168 {
169
170 # Catch sigint and try to cleanup limits
171 trap interrupt_cleanup SIGTERM
172 trap interrupt_cleanup SIGINT
173
174 BW_LIMITS=(3200 1600 800 400 200 100 50 25)
175 for BW in ${BW_LIMITS[@]};
176 do
177 diag "Test high-throughput with bandwidth limit set to ${BW}kbits"
178
179 set_bw_limit $BW
180
181 start_lttng_sessiond
182 start_lttng_relayd "-o $TRACE_PATH"
183 test_high_throughput
184 result=$?
185 stop_lttng_relayd
186 stop_lttng_sessiond
187 reset_bw_limit
188 done
189 }
This page took 0.050415 seconds and 5 git commands to generate.